package net.pluginmedia.utils {
	import flash.net.*;
	import flash.events.*;
	import flash.media.Video;
	import flash.display.*;
	import flash.utils.*;
	import flash.geom.Matrix;

	/**
	 * @author sebleedelisle
	 */
	public class VideoMovieClip extends Sprite
	{
		private var _currentFrame : int; 
		private var _totalFrames : int; 
		private var _playing : Boolean; 
		private var _transparent : Boolean; 
		private var _vid : Video; 
		private var _filename : String; 
		
		private var _playBitmap: Bitmap; 
		private var _playBitmapData: BitmapData; 
		
		public var bitmapArray : Array; 
		
		public var videoWidth : int; 
		public var videoHeight : int;
 
		public var ns:NetStream;
		
		public var videoFramerate:Number ; 
		public var videoFrameDuration:Number; 
		
		public var frameTimer : Timer;
		public var videoDuration : Number; 
		public var currentRecordFrame : int;
		public var lastRecordFrameTime : Number; 
		private var drawmatrix : Matrix; 
		
		
		private var startedRecording:Boolean = false;
		//private var startTime : int;
		private var missingFrameCount : int;
		private var firstPass;

		
		
		
		
		public function VideoMovieClip(filename : String, transparent:Boolean = true) 
		{
			_transparent = transparent; 
			_filename = filename; 
			initialise(); 
			trace("new videomovieclip"); 
		}
		
		public function initialise() :void
		{
		
  			
			var nc:NetConnection = new NetConnection();
			
			nc.connect(null);
			
			ns = new NetStream(nc);
			
			ns.addEventListener(NetStatusEvent.NET_STATUS, netStatusHandler);	
			
			_vid = new Video(320,240);
			_vid.attachNetStream(ns);
			
			ns.client = this;
			ns.play(_filename);	


			bitmapArray = new Array();
			//recordedFrame = new Array(); 
			missingFrameCount = 0; 
			//firstPass = true; 
		}
		
		public function onMetaData(e:Object):void
		{
			trace("onmetadata"); 
			//ns.pause(); 
			//
			if(startedRecording) 
			{
				frameTimer.start(); 
				return ; 
			}
			
			else startedRecording = true; 
			videoFramerate = e["framerate"]; 
			videoDuration = e["duration"];
			
			videoFrameDuration = 1000/videoFramerate; 
			
			videoWidth = e["width"];
			videoHeight = e["height"]; 
			
			

			
			
			_totalFrames = videoFramerate * videoDuration;
			trace("framerate",videoFramerate, "duration", videoDuration,"totalframes", _totalFrames); 
			
			createBitmaps(); 
			
			drawmatrix = new Matrix(); 
			drawmatrix.scale(videoWidth/_vid.width, videoHeight/_vid.height); 
			
			_vid.width = videoWidth; 
			_vid.height = videoHeight; 
			addChild(_vid); 
			//_vid.alpha = 0.5; 
			
			currentRecordFrame = 1; 
			lastRecordFrameTime = 0; 
			ns.seek(0);
			
			firstPass = true; 
			
			recordFrame(0); 
			
			//startTime = getTimer(); 
			
			//frameTimer = new Timer(videoFrameDuration, 0); 
			frameTimer = new Timer(0, 0); 
			frameTimer.addEventListener(TimerEvent.TIMER, captureFrame); 
			frameTimer.start(); 
			
			
		}
		
		public function captureFrame(e:TimerEvent):void
		{
			// legacy code from where we're checking the real timer
			//trace(ns.time*1000, Math.round(getTimer()-startTime));
			//var videoframe:Number = (Math.round((getTimer()-startTime)/videoFrameDuration));
			//var temp: Number = ns.time-lastRecordFrameTime;
			//temp= Math.round(temp/videoFrameDuration); 
			
			
			//var videoframe:Number = Math.round(ns.time*1000/videoFrameDuration); 
			//trace("befor video frame : ", videoframe, "is", ns.time*1000/videoFrameDuration, ns.time); 
			//videoframe = currentRecordFrame+temp; 
			//trace("after video frame : ", videoframe); 
			
			//recordFrame(videoframe);
			//currentRecordFrame = videoframe; 
			
			
			if((ns.time > lastRecordFrameTime)) 
			//if(videoframe>=currentRecordFrame)
			{	
				//trace("RECORDING ", videoframe, "", currentRecordFrame); 
				
				//ns.pause(); 
				var framedifference:Number = (ns.time-lastRecordFrameTime)*1000;
				
				var skippedframes:Number = Math.round(framedifference/videoFrameDuration)-1;
				currentRecordFrame+=skippedframes; 
				//while(skippedframes>0)
				//{
				//	trace("SKIPPED",skippedframes,"FRAME(s)!");
				 	
				// 	currentRecordFrame++;
				// 	skippedframes--;
				//}
				
				recordFrame(currentRecordFrame); 
				
				
				lastRecordFrameTime = ns.time; 
				currentRecordFrame++;
				
			}
			
			

		}
		
		private function recordFrame(frame:int) :void
		{
			//if(recordedFrame[currentRecordFrame]) return;
			
			var bmd:FrameBitmap; 
			trace("record frame ", frame); 
			while(frame>=bitmapArray.length)
			{
				bitmapArray.push(createBitmap()); 
				trace("NOT ENOUGH BITMAPS! - MAKING MORE"); 
				
			}

			//recordedFrame[currentRecordFrame]=true; 
			bmd = bitmapArray[frame];
			if(!bmd.frameRecorded) 
			{
				trace("recording frame "+frame); 
				bmd.recordFrame(_vid, drawmatrix);
				missingFrameCount--; 			
			}
			
		}
		
		private function showBitmaps() : void 
		{
			 
			for(var i:int=0; i < bitmapArray.length ; i++)
			{
				var bm:Bitmap = new Bitmap(bitmapArray[i],"auto", true); 
				bm.y = bm.height;
				bm.scaleX = bm.scaleY = 0.1; 
				bm.x = i*bm.width; 
				
				var maxwidth:int = Math.floor(stage.stageWidth/bm.width)*bm.width; 
				
				while(bm.x>=maxwidth)
				{
					bm.y+=bm.height; 
					bm.x-=maxwidth; 	
					
				}
				
				addChild(bm); 
				
				
			}
			
		}

		
		private function createBitmaps() : void
		{
				
			for(var i:int = 0;i< _totalFrames ;i++)
			{
				var bmd:FrameBitmap = createBitmap()
				bitmapArray[i] = bmd;  
				trace("bitmap made "+i);
			}
			
			
			
			
		}
		private function createBitmap() : FrameBitmap
		{
			missingFrameCount++; 
			return new FrameBitmap(videoWidth, videoHeight, _transparent, 0x33ff0000);
			
		}
		
		private function netStatusHandler(event:NetStatusEvent) : void 
		{
			trace("netstatushandler"); 
			trace(event.info.code); 
			if(event.info.code == "NetStream.Play.Stop")
				finishRecording(); 
		}
		
		private function finishRecording() : void 
		{
			
			if(firstPass)
			{
				_totalFrames = currentRecordFrame; 		
				
				while(bitmapArray.length>=_totalFrames) {
					
					var bmd:FrameBitmap =  bitmapArray.pop(); 
					if(!bmd.frameRecorded) missingFrameCount--;  
				}
				showBitmaps();	
				firstPass = false; 		
				
			}
			
			if(missingFrameCount>0)
			{
				trace("missing frames",missingFrameCount); 
				//trace(recordedFrame); 
				currentRecordFrame = 1; 
				//frameTimer.stop();
				//missingFrameCount = 0; 
				lastRecordFrameTime = 0; 
				//startedRecording = false;  
				frameTimer.stop();
				ns.seek(0); 
				
			} 
			else
			{
				trace("FINISHED!"); 
				trace("TOTAL FRAMES = ", _totalFrames, bitmapArray.length); 
				trace("missing frames",missingFrameCount); 
				//trace(recordedFrame); 
				
				frameTimer.stop();
				initialisePlayer(); 
			
				dispatchEvent(new Event(Event.COMPLETE));  
			}

			
			
		}
	
		public function initialisePlayer()
		{
			addEventListener(Event.ENTER_FRAME, enterFrame); 
			_playBitmapData = new BitmapData(videoWidth, videoHeight, _transparent, 0x00000000); 
			_playBitmap = new Bitmap(_playBitmapData); 


			_currentFrame = 0; 
			addChild(_playBitmap); 
			removeChild(_vid); 
			play(); 	
			
			
		}
		
		public function enterFrame(e:Event)
		{
			if(_playing) 
			{
				_currentFrame++; 
				if (_currentFrame>=bitmapArray.length) _currentFrame = 0;
				if(_transparent)
				{
					_playBitmapData.fillRect(_playBitmapData.rect, 0x00000000); 	
					
				}
				//if(_currentFrame>0)
				//	_playBitmapData.draw(bitmapArray[_currentFrame-1]);
					
				//_playBitmapData.draw(bitmapArray[_currentFrame], null, null, BlendMode.DIFFERENCE); 
			
				_playBitmapData.draw(bitmapArray[_currentFrame]);
				
			}	
			
			
		}
	
		public function play()
		{
			
			_playing = true; 
			
		}
	
		public function onCuePoint(e:Object) : void {};
	}
}
